//
// Shader Example.
// Copyleft (c) 2007 Heesung Oh(Galic Studio). All rights Not reserved.
////////////////////////////////////////////////////////////////////////////


float4x4	m_mtWld;
float4x4	m_mtViw;
float4x4	m_mtPrj;

float4x4	m_mtBlnd[128]: WORLDMATRIXARRAY;	// Blending Matrix Buffer


float4 VtxProc( float3 Pos : POSITION) : POSITION
{
	float4	Pout=0;
	
	Pout = mul(float4(Pos,1), m_mtWld);
	Pout = mul(Pout, m_mtViw);
	Pout = mul(Pout, m_mtPrj);

	return Pout;
}


float4 VtxBlend(float4 Pos: POSITION
			,	float4 Wgt: BLENDWEIGHT
			,	int4   Idx: BLENDINDICES) : POSITION
{
	float4		Pout =0.0f;
	float4x4	mtW = 0.0f;

	float4		Wgx = Wgt;
	Wgx[3] = 1.0f - (Wgx[0] + Wgx[1] + Wgx[2]);

	// Mi * Wi 
	for(int i=0; i<4; ++i)
		mtW += Wgx[i] * m_mtBlnd[Idx[i]];


	// _44  1 ָ   ķ .
	if(mtW._44 <0.001f)
		mtW = float4x4(1,0,0,0,  0,1,0,0,  0,0,1,0,  0,0,0,1);

	mtW = mul(mtW, m_mtWld);		// ü  İ 

	Pout = mul(Pos, mtW);			//  ȯ
	Pout = mul(Pout, m_mtViw);		//  ȯ
	Pout = mul(Pout, m_mtPrj);		//  

	return Pout;
}



technique Tech
{
	pass P0
	{
		VertexShader = compile vs_3_0 VtxProc();
	}

	pass P1
	{
		VertexShader = compile vs_3_0 VtxBlend();
	}
};

