//EShaderBoneMesh.h

#ifndef _ESHADERBONEMESH_H
#define _ESHADERBONEMESH_H

#include <d3d9.h>
#include <d3dx9.h>
#include "EMesh.h"


class XmlNode;

struct ShaderBlendVertex
{
	D3DXVECTOR3 	p;

	FLOAT		weight[3];		// BLEND WEIGHT
	BYTE		boneIndex[4];	// MATRIX Index
	
	ShaderBlendVertex() : p(0,0,0)
	{
		boneIndex[0] = boneIndex[1] = boneIndex[2] = boneIndex[3] = 0;
		weight[0] = weight[1] = weight[2] = 0;
	}

	enum {	FVF = (D3DFVF_XYZB4 | D3DFVF_LASTBETA_UBYTE4),	};
};

struct ShaderBoneVertex
{
	enum { FVF = (D3DFVF_XYZ ) };
	D3DXVECTOR3	p;
};

struct ShaderFaceIncex
{
	WORD n[3];
};

class EShaderBoneMesh : public EMesh
{
public:
	EShaderBoneMesh( LPDIRECT3DDEVICE9 pDevice );
	virtual	~EShaderBoneMesh();

	virtual	const char*	GetClassName();

protected:
	virtual int		OnRender();
	virtual void	OnFrameMove();

public:
	int		CreateVertexBuffer( XmlNode* pXmlNode );

	std::vector<VertexInfo>		m_vertexArr;
	ShaderBlendVertex*			m_pMeshVerts; 
	ShaderBoneVertex*			m_pBoneVerts;

	ShaderFaceIncex*			m_pIndex;
};


#endif