//Shader.h
#ifndef SHADER_H
#define SHADER_H

#include <d3d9.h>
#include <d3dx9.h>

class Shader
{
protected:
	Shader( LPDIRECT3DDEVICE9 pDevice );

public:
	static bool		CreateInstance( LPDIRECT3DDEVICE9 pDevice );
	static Shader*	Instance()  
	{
		return m_pInstance;
	}
	static void		ReleaseInstance();

public:
	virtual ~Shader();
	void    LostDevice();
	void	Restore();
	bool    CreateDeclaration();
	LPD3DXEFFECT  GetEffect()
	{
		return m_pShaderEffect;
	}

	LPDIRECT3DVERTEXDECLARATION9 GetMeshDecl()
	{
		return m_pMeshDecl;
	}

	LPDIRECT3DVERTEXDECLARATION9 GetBoneDecl()
	{
		return m_pBoneDecl;
	}


protected:
	bool	Init();

protected:
	static Shader*			m_pInstance;
	LPDIRECT3DDEVICE9		m_pDevice;

	LPD3DXEFFECT			m_pShaderEffect;
	LPDIRECT3DVERTEXDECLARATION9 m_pMeshDecl;
	LPDIRECT3DVERTEXDECLARATION9 m_pBoneDecl;
};


#endif